## dpkg 1.22.6ubuntu6.5

=== tests/t-conffile-replaces-upgrade/Makefile ===
TESTS_DEB := pkg-conff-original pkg-conff-takeover-0 pkg-conff-takeover-1

include ../Test.mk

TEST_CASES += test-two-run-ordered
TEST_CASES += test-one-run-ordered
TEST_CASES += test-two-run-reverse
TEST_CASES += test-one-run-reverse

test-case: $(TEST_CASES)

define CONFFILES
$(DPKG_QUERY) -f '$${Package} @ $${Conffiles}\n'
endef

define VERIFY
$(call pkg_is_installed,pkg-conff-original)
$(call pkg_is_installed,pkg-conff-takeover)
test "`$(DPKG_QUERY) -S /test-conffile`" = "pkg-conff-takeover: /test-conffile"
test "`$(DPKG_QUERY) -S /test-confpath`" = "pkg-conff-takeover: /test-confpath"
test "`$(CONFFILES) -W pkg-conff-original | grep obsolete | wc -l`" = "2"
test "`$(CONFFILES) -W pkg-conff-takeover | grep -v obsolete | wc -l`" = "2"
cmp ref-conffile "$(DPKG_INSTDIR)/test-conffile"
cmp ref-conffile "$(DPKG_INSTDIR)/test-confpath"
endef

test-two-run-ordered:
	# test-two-run-ordered
	$(DPKG_INSTALL) pkg-conff-original.deb
	$(DPKG_INSTALL) pkg-conff-takeover-0.deb
	$(DPKG_INSTALL) pkg-conff-takeover-1.deb
	$(VERIFY)
	$(DPKG_PURGE) pkg-conff-original pkg-conff-takeover

test-one-run-ordered:
	# test-one-run-ordered
	$(DPKG_INSTALL) pkg-conff-original.deb pkg-conff-takeover-0.deb
	$(DPKG_INSTALL) pkg-conff-takeover-1.deb
	$(VERIFY)
	$(DPKG_PURGE) pkg-conff-original pkg-conff-takeover

test-two-run-reverse:
	# test-two-run-reverse
	$(DPKG_INSTALL) pkg-conff-takeover-0.deb
	$(DPKG_INSTALL) pkg-conff-original.deb
	$(DPKG_INSTALL) pkg-conff-takeover-1.deb
	$(VERIFY)
	$(DPKG_PURGE) pkg-conff-original pkg-conff-takeover

test-one-run-reverse:
	# test-one-run-reverse
	$(DPKG_INSTALL) pkg-conff-takeover-0.deb pkg-conff-original.deb
	$(DPKG_INSTALL) pkg-conff-takeover-1.deb
	$(VERIFY)
	$(DPKG_PURGE) pkg-conff-original pkg-conff-takeover

test-clean:
	$(DPKG_PURGE) pkg-conff-original pkg-conff-takeover

=== tests/t-conflict-provide-replace-interface/Makefile ===
TESTS_DEB := pkg-a pkg-b

include ../Test.mk

test-case:
	$(DPKG_INSTALL) pkg-a.deb
	# The user was not explicit in the request, fail
	! $(DPKG_INSTALL) pkg-b.deb
	# Even if requesting auto-deconfigure the request is not explicit
	# enough, fail
	! $(DPKG_INSTALL) -B pkg-b.deb
	# Set up the desired transaction
	echo pkg-a deinstall | $(BEROOT) $(DPKG) --set-selections
	$(DPKG_INSTALL) pkg-b.deb

test-clean:
	$(DPKG_PURGE) pkg-b
	-$(DPKG_PURGE) pkg-a

=== tests/t-control-no-arch/Makefile ===
include ../Test.mk

test-case:
	# test building package with missing Architecture field.
	! $(DPKG_BUILD_DEB) pkg-no-arch

	# build bogus packages
	$(DPKG_BUILD_DEB) --nocheck pkg-no-arch

	# test handling of package without the Architecture field
	! $(DPKG_INSTALL) pkg-no-arch.deb
	$(call pkg_is_not_installed,pkg-no-arch)
	# these ancient/bogus packages need to be forced now
	$(DPKG_INSTALL) --force-architecture pkg-no-arch.deb
	$(call pkg_is_installed,pkg-no-arch)
	! $(call stdout_has,$(DPKG_QUERY) --status pkg-no-arch,^Architecture:)
	$(DPKG_PURGE) pkg-no-arch
	# Clear the available file to avoid missing Architecture warnings
	$(BEROOT) $(DPKG) --clear-avail

test-clean:
	rm -f pkg-no-arch.deb

=== tests/t-db/Makefile ===
# Copyright © 2012 Guillem Jover <guillem@debian.org>

TESTS_DEB :=

include ../Test.mk

PKG_TUPLE = LC_ALL=C $(DPKG_QUERY) -f '$${Package}:$${Architecture}:$${Version}' -W

TEST_CASES += test-field-blank-lines
TEST_CASES += test-field-blank-lines-update
TEST_CASES += test-dupe-multi
TEST_CASES += test-cross-single-update
TEST_CASES += test-cross-multi-update
TEST_CASES += test-bogus-single
TEST_CASES += test-bogus-dupe-same-single
TEST_CASES += test-bogus-dupe-diff-single
TEST_CASES += test-bogus-multi
TEST_CASES += test-bogus-multi-update

test-case: $(TEST_CASES)

test-field-blank-lines: override DPKG_ADMINDIR = db-field-blank-lines
test-field-blank-lines:
	$(call stderr_has,$(PKG_TUPLE),warning)

test-field-blank-lines-update: override DPKG_ADMINDIR = db-field-blank-lines-update
test-field-blank-lines-update:
	$(call stderr_has,$(PKG_TUPLE),warning)

test-dupe-multi: override DPKG_ADMINDIR = db-dupe-multi
test-dupe-multi:
	$(call stdout_is,$(PKG_TUPLE),pkg-multi:amd64:1.0)

test-cross-single-update: override DPKG_ADMINDIR = db-cross-single-update
test-cross-single-update:
	$(call stdout_is,$(PKG_TUPLE),pkg-single:armel:3.0)

test-cross-multi-update: override DPKG_ADMINDIR = db-cross-multi-update
test-cross-multi-update:
	$(call stdout_is,$(PKG_TUPLE),pkg-multi:armel:4.0)

test-bogus-dupe-same-single: override DPKG_ADMINDIR = db-bogus-dupe-same-single
test-bogus-dupe-same-single:
	$(call stderr_has,$(PKG_TUPLE),error)

test-bogus-dupe-diff-single: override DPKG_ADMINDIR = db-bogus-dupe-diff-single
test-bogus-dupe-diff-single:
	$(call stderr_has,$(PKG_TUPLE),error)

test-bogus-single: override DPKG_ADMINDIR = db-bogus-single
test-bogus-single:
	$(call stderr_has,$(PKG_TUPLE),error)

test-bogus-multi: override DPKG_ADMINDIR = db-bogus-multi
test-bogus-multi:
	$(call stderr_has,$(PKG_TUPLE),error)

test-bogus-multi-update: override DPKG_ADMINDIR = db-bogus-multi-update
test-bogus-multi-update:
	$(call stderr_has,$(PKG_TUPLE),error)

=== tests/t-disappear-empty/Makefile ===
TESTS_DEB := pkg-normal pkg-disappear-0 pkg-disappear-1

include ../Test.mk

test-case:
	$(DPKG_INSTALL) pkg-disappear-0.deb
	# test that an upgraded empty package does not get disappeared
	$(DPKG_INSTALL) pkg-disappear-1.deb
	$(call pkg_is_installed,pkg-disappear)
	$(DPKG_INSTALL) pkg-normal.deb
	$(call pkg_is_installed,pkg-normal)

test-clean:
	$(DPKG_PURGE) pkg-disappear
	$(DPKG_PURGE) pkg-normal

=== tests/t-field-priority/Makefile ===
TESTS_DEB := pkg-priority

include ../Test.mk

test-case:
	# test for unknown priority values
	$(DPKG_INSTALL) pkg-priority.deb
	$(call pkg_is_installed,pkg-priority)
	$(call pkg_field_is,pkg-priority,Priority,value not known)

test-clean:
	$(DPKG_PURGE) pkg-priority

=== tests/t-file-replaces/Makefile ===
TESTS_DEB := pkg-file-original pkg-file-takeover

include ../Test.mk

TEST_CASES += test-two-run-ordered
TEST_CASES += test-one-run-ordered
TEST_CASES += test-two-run-reverse
TEST_CASES += test-one-run-reverse

test-case: $(TEST_CASES)

define VERIFY
$(call pkg_is_installed,pkg-file-original)
$(call pkg_is_installed,pkg-file-takeover)
test "`$(DPKG_QUERY) -S /test-file`" = "pkg-file-takeover: /test-file"
cmp ref-file "$(DPKG_INSTDIR)/test-file"
endef

test-two-run-ordered:
	# test-two-run-ordered
	$(DPKG_INSTALL) pkg-file-original.deb
	$(DPKG_INSTALL) pkg-file-takeover.deb
	$(VERIFY)
	$(DPKG_PURGE) pkg-file-original pkg-file-takeover

test-one-run-ordered:
	# test-one-run-ordered
	$(DPKG_INSTALL) pkg-file-original.deb pkg-file-takeover.deb
	$(VERIFY)
	$(DPKG_PURGE) pkg-file-original pkg-file-takeover

test-two-run-reverse:
	# test-two-run-reverse
	$(DPKG_INSTALL) pkg-file-takeover.deb
	$(DPKG_INSTALL) pkg-file-original.deb
	$(VERIFY)
	$(DPKG_PURGE) pkg-file-original pkg-file-takeover

test-one-run-reverse:
	# test-one-run-reverse
	$(DPKG_INSTALL) pkg-file-takeover.deb pkg-file-original.deb
	$(VERIFY)
	$(DPKG_PURGE) pkg-file-original pkg-file-takeover

=== tests/t-multiarch/Makefile ===
# Copyright © 2011 Linaro Limited
# Copyright © 2011 Raphaël Hertzog <hertzog@debian.org>
# Copyright © 2011-2012 Guillem Jover <guillem@debian.org>

TESTS_DEB :=

include ../Test.mk

NATIVE_ARCH := $(shell dpkg --print-architecture)
ifeq ($(NATIVE_ARCH),i386)
	FOREIGN_ARCH := amd64
else
	FOREIGN_ARCH := i386
endif

ma-setup:
	$(DPKG) --add-architecture $(FOREIGN_ARCH)

## BUILDING THE TEST PACKAGES ##

# Params are (dirname, pkgname, ver, arch, ma, dep)
# Dirname and pkgname are auto-prefixed with "pkg-ma"
define build_pkg
PKG_TO_BUILD += pkg-ma-$(1).deb

pkg-ma-$(1):: pkg-template
	[ -e pkg-ma-$(1) ] || cp -a pkg-template pkg-ma-$(1)
	sed -i -e "s/Package: .*/Package: pkg-ma-$(2)/" \
	       -e "s/Version: .*/Version: $(3)/" \
	       -e "s/Architecture: .*/Architecture: $(4)/" \
	       -e "s/Multi-Arch: .*/Multi-Arch: $(5)/" \
	       -e "s/Depends:.*/Depends: $(6)/" \
	    pkg-ma-$(1)/DEBIAN/control
	mkdir -p pkg-ma-$(1)/m-a
	echo "In file pkg-ma-$(1)" > pkg-ma-$(1)/m-a/foo-$(1)
	touch pkg-ma-$(1)

pkg-ma-$(1).deb: pkg-ma-$(1)
	$(DPKG_BUILD_DEB) --nocheck pkg-ma-$(1) pkg-ma-$(1).deb

clean-hook::
	rm -rf pkg-ma-$(1)
	rm -f pkg-ma-$(1).deb
endef

$(foreach arch,$(NATIVE_ARCH) $(FOREIGN_ARCH),\
  $(foreach ma,same foreign allowed no,\
    $(foreach version,1.0 2.0,\
      $(eval $(call build_pkg,$(ma)_$(version)_$(arch),$(ma),$(version),$(arch),$(ma),)))))

# Arch: all done separately because M-A: same can't be Arch: all
$(foreach ma,foreign allowed no,\
  $(eval $(call build_pkg,$(ma)_1.0_all,$(ma),1.0,all,$(ma),)))

$(eval $(call build_pkg,same_1.0_all,same,1.0,all,no,))

$(foreach arch,$(NATIVE_ARCH) $(FOREIGN_ARCH),\
  $(eval $(call build_pkg,self-conflict_1.0_$(arch),self-conflict,1.0,$(arch),same,))\
  $(foreach ma,same foreign foreign-any allowed allowed-any allowed-fake no,\
    $(eval $(call build_pkg,dep-on-$(ma)_1.0_$(arch),dep-on-$(ma),1.0,$(arch),foreign,pkg-ma-$(subst -,:,$(ma)) (>= 1.0)))))

$(foreach ma,same foreign foreign-any allowed allowed-any allowed-fake no,\
  $(eval $(call build_pkg,dep-on-$(ma)_1.0_all,dep-on-$(ma),1.0,all,no,pkg-ma-$(subst -,:,$(ma)) (>= 1.0))))

shared_file_types := file symlink fifo
ifdef DPKG_AS_ROOT
shared_file_types += chardev blockdev
endif
$(foreach arch,$(NATIVE_ARCH) $(FOREIGN_ARCH),\
  $(foreach version,1.0 2.0,\
    $(eval $(call build_pkg,shared-conffiles_$(version)_orig_$(arch),shared-conffiles,$(version),$(arch),same,))\
    $(eval $(call build_pkg,shared-conffiles_$(version)_alt_$(arch),shared-conffiles,$(version),$(arch),same,))\
    $(foreach variant,orig alt,\
      $(foreach type,$(shared_file_types),\
        $(eval $(call build_pkg,shared-files_$(version)_$(variant)-$(type)_$(arch),shared-files,$(version),$(arch),same,))))))

$(foreach arch,$(NATIVE_ARCH) $(FOREIGN_ARCH),\
  $(eval $(call build_pkg,triggers_1.0_$(arch),triggers,1.0,$(arch),same,))\
  $(eval $(call build_pkg,shared-diversion_1.0_$(arch),shared-diversion,1.0,$(arch),same,)))

$(eval $(call build_pkg,act-trig_1.0_all,act-trig,1.0,all,no,))
$(eval $(call build_pkg,diversion_1.0_all,diversion,1.0,all,no,))
$(eval $(call build_pkg,diverted_1.0_all,diverted,1.0,all,no,))
$(eval $(call build_pkg,db-layout_1.0_$(NATIVE_ARCH),db-layout,1.0,$(NATIVE_ARCH),no,))
$(eval $(call build_pkg,db-layout_2.0_$(NATIVE_ARCH),db-layout,2.0,$(NATIVE_ARCH),same,))

build-hook: $(PKG_TO_BUILD)

## TEST CASES BELOW ##

TEST_CASES += test-print-foreign-architecture
TEST_CASES += test-build-invalid
TEST_CASES += test-build-valid
TEST_CASES += test-install-native
TEST_CASES += test-install-foreign
TEST_CASES += test-coinstall-ma-same
TEST_CASES += test-crossgrade
TEST_CASES += test-deps
TEST_CASES += test-coinstall-shared-files
TEST_CASES += test-coinstall-shared-conffiles
TEST_CASES += test-coinstall-triggers
TEST_CASES += test-coinstall-diversions
TEST_CASES += test-dpkg-output
TEST_CASES += test-db-layout

test-case: $(TEST_CASES)

test-print-foreign-architecture:
	echo $(FOREIGN_ARCH) >ref-arch
	echo foobar >>ref-arch
	$(DPKG) --remove-architecture $(FOREIGN_ARCH)
	$(DPKG) --remove-architecture foobar
	$(call stdout_is,$(DPKG) --print-foreign-architectures,)
	$(DPKG) --add-architecture $(FOREIGN_ARCH)
	$(call stdout_is,$(DPKG) --print-foreign-architectures,$(FOREIGN_ARCH))
	$(DPKG) --add-architecture foobar
	$(DPKG) --print-foreign-architectures | cmp ref-arch -
	# Ensure all/any can't be added as foreign arch
	! $(DPKG) --add-architecture all
	! $(DPKG) --add-architecture any
	# Ensure the native arch is never considered as
	$(DPKG) --add-architecture $(NATIVE_ARCH)
	$(DPKG) --print-foreign-architectures | cmp ref-arch -
	$(DPKG) --remove-architecture foobar
	rm -f ref-arch

test-build-invalid:
	# Test build of Architecture: all with Multi-Arch: same field
	! $(DPKG_BUILD_DEB) pkg-template foo.deb
	rm -f foo.deb

test-build-valid:
	# Test build of package with valid dependency (ma-allowed:fake)
	$(DPKG_BUILD_DEB) pkg-ma-dep-on-allowed-fake_1.0_$(NATIVE_ARCH) foo.deb
	rm -f foo.deb

test-install-native:
	$(DPKG_INSTALL) pkg-ma-same_1.0_$(NATIVE_ARCH).deb
	$(DPKG_INSTALL) pkg-ma-foreign_1.0_$(NATIVE_ARCH).deb
	$(DPKG_INSTALL) pkg-ma-allowed_1.0_$(NATIVE_ARCH).deb
	$(DPKG_INSTALL) pkg-ma-no_1.0_$(NATIVE_ARCH).deb
	$(call pkg_is_installed,pkg-ma-same:$(NATIVE_ARCH))
	$(call pkg_is_installed,pkg-ma-foreign)
	$(call pkg_is_installed,pkg-ma-allowed)
	$(call pkg_is_installed,pkg-ma-no)
	$(DPKG_PURGE) pkg-ma-same:$(NATIVE_ARCH) pkg-ma-foreign pkg-ma-allowed pkg-ma-no
	$(call pkg_is_not_installed,pkg-ma-same:$(NATIVE_ARCH))
	$(call pkg_is_not_installed,pkg-ma-foreign)
	$(call pkg_is_not_installed,pkg-ma-allowed)
	$(call pkg_is_not_installed,pkg-ma-no)

test-install-foreign:
	$(DPKG) --remove-architecture $(FOREIGN_ARCH)
	# Installation of foreign arch packages must fail by default
	! $(DPKG_INSTALL) pkg-ma-same_1.0_$(FOREIGN_ARCH).deb
	! $(DPKG_INSTALL) pkg-ma-foreign_1.0_$(FOREIGN_ARCH).deb
	! $(DPKG_INSTALL) pkg-ma-allowed_1.0_$(FOREIGN_ARCH).deb
	! $(DPKG_INSTALL) pkg-ma-no_1.0_$(FOREIGN_ARCH).deb
	# Once architecture has been added it should succeed
	$(DPKG) --add-architecture $(FOREIGN_ARCH)
	$(DPKG_INSTALL) pkg-ma-same_1.0_$(FOREIGN_ARCH).deb
	$(DPKG_INSTALL) pkg-ma-foreign_1.0_$(FOREIGN_ARCH).deb
	$(DPKG_INSTALL) pkg-ma-allowed_1.0_$(FOREIGN_ARCH).deb
	$(DPKG_INSTALL) pkg-ma-no_1.0_$(FOREIGN_ARCH).deb
	$(call pkg_is_installed,pkg-ma-same:$(FOREIGN_ARCH))
	$(call pkg_is_installed,pkg-ma-foreign:$(FOREIGN_ARCH))
	$(call pkg_is_installed,pkg-ma-allowed:$(FOREIGN_ARCH))
	$(call pkg_is_installed,pkg-ma-no:$(FOREIGN_ARCH))
	$(DPKG_PURGE) pkg-ma-same:$(FOREIGN_ARCH) pkg-ma-foreign:$(FOREIGN_ARCH) pkg-ma-allowed:$(FOREIGN_ARCH) pkg-ma-no:$(FOREIGN_ARCH)
	$(call pkg_is_not_installed,pkg-ma-same:$(FOREIGN_ARCH))
	$(call pkg_is_not_installed,pkg-ma-foreign:$(FOREIGN_ARCH))
	$(call pkg_is_not_installed,pkg-ma-allowed:$(FOREIGN_ARCH))
	$(call pkg_is_not_installed,pkg-ma-no:$(FOREIGN_ARCH))

test-coinstall-ma-same: ma-setup
	# Coinstall 2 Multi-Arch: same packages
	$(DPKG_INSTALL) pkg-ma-same_1.0_$(NATIVE_ARCH).deb
	$(DPKG_INSTALL) pkg-ma-same_1.0_$(FOREIGN_ARCH).deb
	$(call pkg_is_installed,pkg-ma-same:$(NATIVE_ARCH))
	$(call pkg_is_installed,pkg-ma-same:$(FOREIGN_ARCH))
	# Upgrade one, the other must be unconfigured
	$(DPKG_UNPACK) pkg-ma-same_2.0_$(NATIVE_ARCH).deb
	$(call pkg_status_is,pkg-ma-same:$(NATIVE_ARCH),install ok unpacked)
	$(call pkg_status_is,pkg-ma-same:$(FOREIGN_ARCH),install ok half-configured)
	# Configure one alone must fail
	! $(DPKG_CONFIGURE) pkg-ma-same:$(NATIVE_ARCH)
	! $(DPKG_CONFIGURE) pkg-ma-same:$(FOREIGN_ARCH)
	# Upgrade the other and it's now possible to configure them
	$(DPKG_UNPACK) pkg-ma-same_2.0_$(FOREIGN_ARCH).deb
	$(DPKG_CONFIGURE) --pending
	$(call pkg_is_installed,pkg-ma-same:$(NATIVE_ARCH))
	$(call pkg_is_installed,pkg-ma-same:$(FOREIGN_ARCH))
	$(DPKG_PURGE) pkg-ma-same:$(NATIVE_ARCH) pkg-ma-same:$(FOREIGN_ARCH)

TEST_CASES_CROSSGRADE :=
TEST_CASES_CROSSGRADE += test-crossgrade-foreign-allowed

test-crossgrade: $(TEST_CASES_CROSSGRADE)

test-crossgrade-foreign-allowed: ma-setup
	# Ensure we can cross-grade Multi-Arch: foreign/allowed
	$(DPKG_INSTALL) pkg-ma-foreign_1.0_$(NATIVE_ARCH).deb
	$(DPKG_INSTALL) pkg-ma-foreign_1.0_$(FOREIGN_ARCH).deb
	$(DPKG_INSTALL) pkg-ma-allowed_1.0_$(FOREIGN_ARCH).deb
	$(DPKG_INSTALL) pkg-ma-allowed_1.0_$(NATIVE_ARCH).deb
	$(DPKG_PURGE) pkg-ma-foreign:$(NATIVE_ARCH) pkg-ma-allowed:$(FOREIGN_ARCH)

TEST_CASES_CROSSGRADE :=
TEST_CASES_CROSSGRADE += test-crossgrade-any-all-same
TEST_CASES_CROSSGRADE += test-crossgrade-any-all-foreign
TEST_CASES_CROSSGRADE += test-crossgrade-any-all-allowed
TEST_CASES_CROSSGRADE += test-crossgrade-all-any-same
TEST_CASES_CROSSGRADE += test-crossgrade-all-any-foreign
TEST_CASES_CROSSGRADE += test-crossgrade-all-any-allowed
TEST_CASES_CROSSGRADE += test-crossgrade-same-all
TEST_CASES_CROSSGRADE += test-crossgrade-no

test-crossgrade: $(TEST_CASES_CROSSGRADE)

test-crossgrade-any-all-%: ma-setup
	# M-A: $* / Upgrade from arch: any-native -> all
	$(DPKG_INSTALL) pkg-ma-$*_1.0_$(NATIVE_ARCH).deb
	$(DPKG_INSTALL) pkg-ma-$*_1.0_all.deb
	$(call pkg_is_installed,pkg-ma-$*:all)
	$(call pkg_is_not_installed,pkg-ma-$*:$(NATIVE_ARCH))
	$(call pkg_field_is,pkg-ma-$*,Architecture,all)
	$(DPKG_PURGE) pkg-ma-$*
	$(call pkg_is_not_installed,pkg-ma-$*)
	# M-A: $* / Upgrade from arch: any-foreign -> all
	$(DPKG_INSTALL) pkg-ma-$*_1.0_$(FOREIGN_ARCH).deb
	$(DPKG_INSTALL) pkg-ma-$*_1.0_all.deb
	$(call pkg_is_installed,pkg-ma-$*:all)
	$(call pkg_is_not_installed,pkg-ma-$*:$(FOREIGN_ARCH))
	$(DPKG_PURGE) pkg-ma-$*

test-crossgrade-all-any-%: ma-setup
	# M-A: $* / Upgrade from arch: all -> any-native
	$(DPKG_INSTALL) pkg-ma-$*_1.0_all.deb
	$(DPKG_INSTALL) pkg-ma-$*_1.0_$(NATIVE_ARCH).deb
	$(call pkg_is_installed,pkg-ma-$*:$(NATIVE_ARCH))
	$(call pkg_is_not_installed,pkg-ma-$*:all)
	$(call pkg_field_is,pkg-ma-$*,Architecture,$(NATIVE_ARCH))
	$(DPKG_PURGE) pkg-ma-$*:$(NATIVE_ARCH)
	$(call pkg_is_not_installed,pkg-ma-$*:all)
	$(call pkg_is_not_installed,pkg-ma-$*:$(NATIVE_ARCH))
	# M-A: $* / Upgrade from arch: all -> any-foreign
	$(DPKG_INSTALL) pkg-ma-$*_1.0_all.deb
	$(DPKG_INSTALL) pkg-ma-$*_1.0_$(FOREIGN_ARCH).deb
	$(call pkg_is_not_installed,pkg-ma-$*:all)
	$(call pkg_is_installed,pkg-ma-$*:$(FOREIGN_ARCH))
	$(DPKG_PURGE) pkg-ma-$*

test-crossgrade-same-all: ma-setup
	# Several M-A: same installed, can't upgrade to single arch all
	$(DPKG_INSTALL) pkg-ma-same_1.0_$(NATIVE_ARCH).deb
	$(DPKG_INSTALL) pkg-ma-same_1.0_$(FOREIGN_ARCH).deb
	! $(DPKG_INSTALL) pkg-ma-same_1.0_all.deb
	$(call pkg_is_installed,pkg-ma-same:$(NATIVE_ARCH))
	$(call pkg_is_installed,pkg-ma-same:$(FOREIGN_ARCH))
	$(call pkg_is_not_installed,pkg-ma-same:all)
	$(DPKG_PURGE) pkg-ma-same:$(NATIVE_ARCH) pkg-ma-same:$(FOREIGN_ARCH)

pkg-ma-no_1.0_$(NATIVE_ARCH) pkg-ma-no_1.0_$(FOREIGN_ARCH):: pkg-template
	echo "A conffile" > $@/m-a/conffile-$@
	echo "/m-a/conffile-$@" > $@/DEBIAN/conffiles

test-crossgrade-no: ma-setup
	$(DPKG_INSTALL) pkg-ma-no_1.0_$(NATIVE_ARCH).deb
	$(DPKG_REMOVE) pkg-ma-no:$(NATIVE_ARCH)
	$(call pkg_status_is,pkg-ma-no:$(NATIVE_ARCH),deinstall ok config-files)
	$(call pkg_is_not_installed,pkg-ma-no:$(FOREIGN_ARCH))
	$(call stdout_has,$(DPKG_QUERY) -L pkg-ma-no,/m-a/conffile-pkg-ma-no_1.0_$(NATIVE_ARCH))
	$(DPKG_INSTALL) pkg-ma-no_1.0_$(FOREIGN_ARCH).deb
	# Verify the replaced package disappeared
	$(call pkg_is_not_installed,pkg-ma-no:$(NATIVE_ARCH))
	$(call pkg_is_installed,pkg-ma-no:$(FOREIGN_ARCH))
	$(call stdout_has,$(DPKG_QUERY) -L pkg-ma-no:$(FOREIGN_ARCH),/m-a/conffile-pkg-ma-no_1.0_$(FOREIGN_ARCH))
	# Ensure the conffile of the disappeared package is still tracked
	$(call stdout_has,$(DPKG_QUERY) -L pkg-ma-no:$(FOREIGN_ARCH),/m-a/conffile-pkg-ma-no_1.0_$(NATIVE_ARCH))
	$(call stdout_has,$(DPKG_QUERY) -f '$${Conffiles}' -W pkg-ma-no:$(FOREIGN_ARCH), /m-a/conffile-pkg-ma-no_1.0_$(NATIVE_ARCH) [a-f0-9]+ obsolete$$)
	$(DPKG_PURGE) pkg-ma-no:$(FOREIGN_ARCH)

TEST_CASES_DEPS :=
TEST_CASES_DEPS += test-deps-same

=== tests/t-provides-arch-qualified/Makefile ===
TESTS_DEB := pkg-a pkg-b

include ../Test.mk

test-case:
	$(DPKG) --add-architecture i386
	$(DPKG) --add-architecture amd64
	$(DPKG_INSTALL) pkg-a.deb
	# test if the conflicting package fails on install
	! $(DPKG_INSTALL) pkg-b.deb

test-clean:
	$(DPKG_PURGE) pkg-b
	$(DPKG_PURGE) pkg-a
	$(DPKG) --remove-architecture i386
	$(DPKG) --remove-architecture amd64

=== tests/t-provides/Makefile ===
TESTS_DEB := \
	pkg-provides pkg-provides-10 pkg-provides-20 pkg-provides-10-20 \
	pkg-depends pkg-depends-eq pkg-depends-le pkg-depends-ge \
	pkg-predepends pkg-predepends-eq pkg-predepends-le pkg-predepends-ge \
	pkg-breaks pkg-breaks-eq pkg-breaks-le pkg-breaks-ge \
	pkg-conflicts pkg-conflicts-eq pkg-conflicts-le pkg-conflicts-ge \
	pkg-a-depends-ge-lt pkg-b-provides-10 pkg-c-provides-20

include ../Test.mk

define PURGE_DEPENDS
$(DPKG_PURGE) pkg-depends
$(DPKG_PURGE) pkg-depends-le
$(DPKG_PURGE) pkg-depends-eq
$(DPKG_PURGE) pkg-depends-ge
endef

test-depends:
	# The provided dependency is not present, fail
	! $(DPKG_INSTALL) pkg-depends.deb
	! $(DPKG_INSTALL) pkg-depends-eq.deb
	! $(DPKG_INSTALL) pkg-depends-le.deb
	! $(DPKG_INSTALL) pkg-depends-ge.deb

	# Install the providing package (versionless)
	$(DPKG_INSTALL) pkg-provides.deb
	$(DPKG_INSTALL) pkg-depends.deb
	! $(DPKG_INSTALL) pkg-depends-eq.deb
	! $(DPKG_INSTALL) pkg-depends-le.deb
	! $(DPKG_INSTALL) pkg-depends-ge.deb
	# Upgrade the providing package (versionless)
	$(DPKG_INSTALL) pkg-provides.deb
	! $(DPKG_PURGE) pkg-provides

	$(PURGE_DEPENDS)

	# Install the providing package (pkg-virtual 10)
	$(DPKG_INSTALL) pkg-provides-10.deb
	$(DPKG_INSTALL) pkg-depends.deb
	$(DPKG_INSTALL) pkg-depends-le.deb
	! $(DPKG_INSTALL) pkg-depends-eq.deb
	! $(DPKG_INSTALL) pkg-depends-ge.deb
	# Upgrade the providing package (pkg-virtual 10)
	$(DPKG_INSTALL) pkg-provides-10.deb

	$(PURGE_DEPENDS)

	# Install the providing package (pkg-virtual 20)
	$(DPKG_INSTALL) pkg-provides-20.deb
	$(DPKG_INSTALL) pkg-depends.deb
	$(DPKG_INSTALL) pkg-depends-eq.deb
	! $(DPKG_INSTALL) pkg-depends-le.deb
	$(DPKG_INSTALL) pkg-depends-ge.deb
	# Upgrade the providing package (pkg-virtual 20)
	$(DPKG_INSTALL) pkg-provides-20.deb

	$(PURGE_DEPENDS)

	# Install the providing package (pkg-virtual 10 && 20)
	$(DPKG_INSTALL) pkg-provides-10-20.deb
	$(DPKG_INSTALL) pkg-depends.deb
	$(DPKG_INSTALL) pkg-depends-eq.deb
	$(DPKG_INSTALL) pkg-depends-le.deb
	$(DPKG_INSTALL) pkg-depends-ge.deb
	# Upgrade the providing package (pkg-virtual 10 && 20)
	$(DPKG_INSTALL) pkg-provides-10-20.deb

	$(PURGE_DEPENDS)

	$(DPKG_PURGE) pkg-provides

	# Install the providing package (pkg-virtual 20)
	$(DPKG_INSTALL) pkg-c-provides-20.deb
	! $(DPKG_INSTALL) pkg-a-depends-ge-lt.deb
	$(DPKG_PURGE) pkg-a-depends-ge-lt
	$(DPKG_PURGE) pkg-c-provides

	# Install the providing package (pkg-virtual 10)
	$(DPKG_INSTALL) pkg-b-provides-10.deb
	$(DPKG_INSTALL) pkg-a-depends-ge-lt.deb
	# Install the providing package (pkg-virtual 20)
	$(DPKG_INSTALL) pkg-c-provides-20.deb

	# Cannot purge the only package satisfying the dependency
	! $(DPKG_PURGE) pkg-b-provides
	# Can purge package not satisfying the dependency
	$(DPKG_PURGE) pkg-c-provides

	$(DPKG_PURGE) pkg-a-depends-ge-lt
	$(DPKG_PURGE) pkg-b-provides

	# The provided dependency is removed, pass
	$(DPKG_PURGE) pkg-provides

define PURGE_PREDEPENDS
$(DPKG_PURGE) pkg-predepends
$(DPKG_PURGE) pkg-predepends-le
$(DPKG_PURGE) pkg-predepends-eq
$(DPKG_PURGE) pkg-predepends-ge
endef

test-predepends:
	# The provided predependency is not present, fail
	! $(DPKG_UNPACK) pkg-predepends.deb
	! $(DPKG_UNPACK) pkg-predepends-eq.deb
	! $(DPKG_UNPACK) pkg-predepends-le.deb
	! $(DPKG_UNPACK) pkg-predepends-ge.deb

	# Install the providing package (versionless)
	$(DPKG_INSTALL) pkg-provides.deb
	$(DPKG_UNPACK) pkg-predepends.deb
	! $(DPKG_UNPACK) pkg-predepends-eq.deb
	! $(DPKG_UNPACK) pkg-predepends-le.deb
	! $(DPKG_UNPACK) pkg-predepends-ge.deb
	# Upgrade the providing package (versionless)
	$(DPKG_INSTALL) pkg-provides.deb
	! $(DPKG_PURGE) pkg-provides

	$(PURGE_PREDEPENDS)

	# Install the providing package (pkg-virtual 10)
	$(DPKG_INSTALL) pkg-provides-10.deb
	$(DPKG_UNPACK) pkg-predepends.deb
	$(DPKG_UNPACK) pkg-predepends-le.deb
	! $(DPKG_UNPACK) pkg-predepends-eq.deb
	! $(DPKG_UNPACK) pkg-predepends-ge.deb
	# Upgrade the providing package (pkg-virtual 10)
	$(DPKG_INSTALL) pkg-provides-10.deb

	$(PURGE_PREDEPENDS)

	# Install the providing package (pkg-virtual 20)
	$(DPKG_INSTALL) pkg-provides-20.deb
	$(DPKG_UNPACK) pkg-predepends.deb
	$(DPKG_UNPACK) pkg-predepends-eq.deb
	! $(DPKG_UNPACK) pkg-predepends-le.deb
	$(DPKG_UNPACK) pkg-predepends-ge.deb
	# Upgrade the providing package (pkg-virtual 20)
	$(DPKG_INSTALL) pkg-provides-20.deb

	$(PURGE_PREDEPENDS)

	# Install the providing package (pkg-virtual 10 && 20)
	$(DPKG_INSTALL) pkg-provides-10-20.deb
	$(DPKG_UNPACK) pkg-predepends.deb
	$(DPKG_UNPACK) pkg-predepends-eq.deb
	$(DPKG_UNPACK) pkg-predepends-le.deb
	$(DPKG_UNPACK) pkg-predepends-ge.deb
	# Upgrade the providing package (pkg-virtual 10 && 20)
	$(DPKG_INSTALL) pkg-provides-10-20.deb

	$(PURGE_PREDEPENDS)

	# The provided predependency is removed, pass
	$(DPKG_PURGE) pkg-provides

define PURGE_BREAKS
$(DPKG_PURGE) pkg-breaks
$(DPKG_PURGE) pkg-breaks-le
$(DPKG_PURGE) pkg-breaks-eq
$(DPKG_PURGE) pkg-breaks-ge
endef

test-breaks:
	# The provided dependency is not present, pass
	$(DPKG_INSTALL) pkg-breaks.deb
	$(DPKG_INSTALL) pkg-breaks-eq.deb
	$(DPKG_INSTALL) pkg-breaks-le.deb
	$(DPKG_INSTALL) pkg-breaks-ge.deb

	$(PURGE_BREAKS)

	# Install the providing package (versionless)
	$(DPKG_INSTALL) pkg-provides.deb
	! $(DPKG_INSTALL) pkg-breaks.deb
	$(DPKG_INSTALL) pkg-breaks-eq.deb
	$(DPKG_INSTALL) pkg-breaks-le.deb
	$(DPKG_INSTALL) pkg-breaks-ge.deb
	# Upgrade the providing package (versionless)
	$(DPKG_INSTALL) pkg-provides.deb
	$(DPKG_PURGE) pkg-provides

	$(PURGE_BREAKS)

	# Install the providing package (pkg-virtual 10)
	$(DPKG_INSTALL) pkg-provides-10.deb
	! $(DPKG_INSTALL) pkg-breaks.deb
	! $(DPKG_INSTALL) pkg-breaks-le.deb
	$(DPKG_INSTALL) pkg-breaks-eq.deb
	$(DPKG_INSTALL) pkg-breaks-ge.deb
	# Upgrade the providing package (pkg-virtual 10)
	$(DPKG_INSTALL) pkg-provides-10.deb

	$(PURGE_BREAKS)

	# Install the providing package (pkg-virtual 20)
	$(DPKG_INSTALL) pkg-provides-20.deb
	! $(DPKG_INSTALL) pkg-breaks.deb
	! $(DPKG_INSTALL) pkg-breaks-eq.deb
	$(DPKG_INSTALL) pkg-breaks-le.deb
	! $(DPKG_INSTALL) pkg-breaks-ge.deb
	# Upgrade the providing package (pkg-virtual 20)
	$(DPKG_INSTALL) pkg-provides-20.deb

	$(PURGE_BREAKS)

	# Install the providing package (pkg-virtual 10 && 20)
	$(DPKG_INSTALL) pkg-provides-10-20.deb
	! $(DPKG_INSTALL) pkg-breaks.deb
	! $(DPKG_INSTALL) pkg-breaks-eq.deb
	! $(DPKG_INSTALL) pkg-breaks-le.deb
	! $(DPKG_INSTALL) pkg-breaks-ge.deb
	# Upgrade the providing package (pkg-virtual 10 && 20)
	$(DPKG_INSTALL) pkg-provides-10-20.deb

	$(PURGE_BREAKS)

	# The provided dependency is removed, pass
	$(DPKG_PURGE) pkg-provides

define PURGE_CONFLICTS
$(DPKG_PURGE) pkg-conflicts
$(DPKG_PURGE) pkg-conflicts-le
$(DPKG_PURGE) pkg-conflicts-eq
$(DPKG_PURGE) pkg-conflicts-ge
endef

test-conflicts:
	# The provided predependency is not present, fail
	$(DPKG_UNPACK) pkg-conflicts.deb
	$(DPKG_UNPACK) pkg-conflicts-eq.deb
	$(DPKG_UNPACK) pkg-conflicts-le.deb
	$(DPKG_UNPACK) pkg-conflicts-ge.deb

	$(PURGE_CONFLICTS)

	# Install the providing package (versionless)
	$(DPKG_INSTALL) pkg-provides.deb
	! $(DPKG_UNPACK) pkg-conflicts.deb
	$(DPKG_UNPACK) pkg-conflicts-eq.deb
	$(DPKG_UNPACK) pkg-conflicts-le.deb
	$(DPKG_UNPACK) pkg-conflicts-ge.deb
	# Upgrade the providing package (pkg-virtual versionless)
	$(DPKG_INSTALL) pkg-provides.deb
	$(DPKG_PURGE) pkg-provides

	$(PURGE_CONFLICTS)

	# Install the providing package (pkg-virtual 10)
	$(DPKG_INSTALL) pkg-provides-10.deb
	! $(DPKG_UNPACK) pkg-conflicts.deb
	! $(DPKG_UNPACK) pkg-conflicts-le.deb
	$(DPKG_UNPACK) pkg-conflicts-eq.deb
	$(DPKG_UNPACK) pkg-conflicts-ge.deb
	# Upgrade the providing package (pkg-virtual 10)
	$(DPKG_INSTALL) pkg-provides-10.deb

	$(PURGE_CONFLICTS)

	# Install the providing package (pkg-virtual 20)
	$(DPKG_INSTALL) pkg-provides-20.deb
	! $(DPKG_UNPACK) pkg-conflicts.deb
	! $(DPKG_UNPACK) pkg-conflicts-eq.deb
	$(DPKG_UNPACK) pkg-conflicts-le.deb
	! $(DPKG_UNPACK) pkg-conflicts-ge.deb
	# Upgrade the providing package (pkg-virtual 20)
	$(DPKG_INSTALL) pkg-provides-20.deb

	$(PURGE_CONFLICTS)

	# Install the providing package (pkg-virtual 10 && 20)
	$(DPKG_INSTALL) pkg-provides-10-20.deb
	! $(DPKG_UNPACK) pkg-conflicts.deb
	! $(DPKG_UNPACK) pkg-conflicts-eq.deb
	! $(DPKG_UNPACK) pkg-conflicts-le.deb
	! $(DPKG_UNPACK) pkg-conflicts-ge.deb
	# Upgrade the providing package (pkg-virtual 10 && 20)
	$(DPKG_INSTALL) pkg-provides-10-20.deb

	$(PURGE_CONFLICTS)

	# The provided predependency is removed, pass
	$(DPKG_PURGE) pkg-provides

test-case: test-depends test-predepends test-breaks test-conflicts

test-clean:
	-$(DPKG_PURGE) pkg-depends
	-$(DPKG_PURGE) pkg-depends-eq
	-$(DPKG_PURGE) pkg-depends-ge
	-$(DPKG_PURGE) pkg-depends-le
	-$(DPKG_PURGE) pkg-predepends
	-$(DPKG_PURGE) pkg-predepends-eq
	-$(DPKG_PURGE) pkg-predepends-ge
	-$(DPKG_PURGE) pkg-predepends-le
	-$(DPKG_PURGE) pkg-breaks
	-$(DPKG_PURGE) pkg-breaks-eq
	-$(DPKG_PURGE) pkg-breaks-ge
	-$(DPKG_PURGE) pkg-breaks-le
	-$(DPKG_PURGE) pkg-conflicts
	-$(DPKG_PURGE) pkg-conflicts-eq
	-$(DPKG_PURGE) pkg-conflicts-ge
	-$(DPKG_PURGE) pkg-conflicts-le
	-$(DPKG_PURGE) pkg-provides
	-$(DPKG_PURGE) pkg-a-depends-ge-lt
	-$(DPKG_PURGE) pkg-b-provides
	-$(DPKG_PURGE) pkg-c-provides

=== tests/t-queue-process-deconf-dupe/Makefile ===
TESTS_DEB := pkg-a-0 pkg-a-1 pkg-b

include ../Test.mk

DPKG_OPTIONS += --auto-deconfigure

test-case:
	$(DPKG_INSTALL) pkg-a-0.deb
	$(DPKG_INSTALL) pkg-b.deb pkg-a-1.deb

test-clean:
	$(DPKG_PURGE) pkg-b pkg-a

=== tests/t-switch-dir-to-symlink-rel/Makefile ===
TESTS_DEB := \
	pkg-dir-conffile-0 pkg-dir-conffile-1 \
	pkg-dir-file-other pkg-dir-symlink-int-0 pkg-dir-symlink-int-1 \
	pkg-dir-file-moved pkg-dir-symlink-ext-0 pkg-dir-symlink-ext-1

include ../Test.mk

build-hook:
	mkdir -p pkg-dir-conffile-1/test-path
	ln -sfT ../test-dir pkg-dir-conffile-1/test-path/test-subpath
	mkdir -p pkg-dir-symlink-ext-1/test-path
	ln -sfT ../test-dir pkg-dir-symlink-ext-1/test-path/test-subpath
	mkdir -p pkg-dir-symlink-int-1/test-path
	ln -sfT ../test-dir pkg-dir-symlink-int-1/test-path/test-subpath

clean-hook:
	$(RM) pkg-dir-conffile-1/test-path/test-subpath
	-rmdir pkg-dir-conffile-1/test-path
	$(RM) pkg-dir-symlink-ext-1/test-path/test-subpath
	-rmdir pkg-dir-symlink-ext-1/test-path
	$(RM) pkg-dir-symlink-int-1/test-path/test-subpath
	-rmdir pkg-dir-symlink-int-1/test-path

test-case:
	# Cannot switch a directory containing conffiles
	$(DPKG_INSTALL) pkg-dir-conffile-0.deb
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	! $(DPKG_INSTALL) pkg-dir-conffile-1.deb
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	$(DPKG_PURGE) pkg-dir-conffile

	# Cannot switch a directory containing files owned by another package
	$(DPKG_INSTALL) pkg-dir-file-other.deb
	$(DPKG_INSTALL) pkg-dir-symlink-int-0.deb
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	! test -h '$(DPKG_INSTDIR)/test-path/test-subpath'
	! $(DPKG_INSTALL) pkg-dir-symlink-int-1.deb
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	! test -h '$(DPKG_INSTDIR)/test-path/test-subpath'
	$(DPKG_PURGE) pkg-dir-symlink-int
	$(DPKG_PURGE) pkg-dir-file-other

	# Cannot switch a directory containing local files
	$(DPKG_INSTALL) pkg-dir-symlink-int-0.deb
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	! test -h '$(DPKG_INSTDIR)/test-path/test-subpath'
	touch '$(DPKG_INSTDIR)/test-path/test-subpath/local file'
	! $(DPKG_INSTALL) pkg-dir-symlink-int-1.deb
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	! test -h '$(DPKG_INSTDIR)/test-path/test-subpath'
	rm '$(DPKG_INSTDIR)/test-path/test-subpath/local file'
	$(DPKG_PURGE) pkg-dir-symlink-int

	#
	# Otherwise allow the switch
	#

	# Switch a directory to a symlink, contents moved within the package,
	# with intermediate full installs.
	$(DPKG_INSTALL) pkg-dir-symlink-int-0.deb
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	! test -h '$(DPKG_INSTDIR)/test-path/test-subpath'
	$(DPKG_INSTALL) pkg-dir-symlink-int-1.deb
	test -h '$(DPKG_INSTDIR)/test-path/test-subpath'
	$(DPKG_PURGE) pkg-dir-symlink-int
	! test -e '$(DPKG_INSTDIR)/test-path/test-subpath'

	# Switch a directory to a symlink, contents moved within the package,
	# with full install, upgrade with upack and configure.
	$(DPKG_INSTALL) pkg-dir-symlink-int-0.deb
	! test -h '$(DPKG_INSTDIR)/test-path/test-subpath'
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	$(DPKG_UNPACK) pkg-dir-symlink-int-1.deb
	! test -h '$(DPKG_INSTDIR)/test-path/test-subpath'
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	$(DPKG_CONFIGURE) pkg-dir-symlink-int
	test -h '$(DPKG_INSTDIR)/test-path/test-subpath'
	$(DPKG_PURGE) pkg-dir-symlink-int
	! test -e '$(DPKG_INSTDIR)/test-path/test-subpath'

	# Switch a directory to a symlink, contents moved within the package,
	# with two unpacks and configure.
	$(DPKG_UNPACK) pkg-dir-symlink-int-0.deb
	! test -h '$(DPKG_INSTDIR)/test-path/test-subpath'
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	$(DPKG_UNPACK) pkg-dir-symlink-int-1.deb
	! test -h '$(DPKG_INSTDIR)/test-path/test-subpath'
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	$(DPKG_CONFIGURE) pkg-dir-symlink-int
	test -h '$(DPKG_INSTDIR)/test-path/test-subpath'
	$(DPKG_PURGE) pkg-dir-symlink-int
	! test -e '$(DPKG_INSTDIR)/test-path/test-subpath'

	# Switch a directory to a symlink, contents moved to another package,
	# with intermediate full installs.
	$(DPKG_INSTALL) pkg-dir-symlink-ext-0.deb
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	$(DPKG_INSTALL) pkg-dir-file-moved.deb
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	test -d '$(DPKG_INSTDIR)/test-dir'
	$(DPKG_INSTALL) pkg-dir-symlink-ext-1.deb
	test -h '$(DPKG_INSTDIR)/test-path/test-subpath'
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	test "`readlink '$(DPKG_INSTDIR)/test-path/test-subpath'`" = "../test-dir"
	! test -h '$(DPKG_INSTDIR)/test-dir'
	test -d '$(DPKG_INSTDIR)/test-dir'
	test -f '$(DPKG_INSTDIR)/test-dir/file-normal'
	$(DPKG_PURGE) pkg-dir-symlink-ext
	$(DPKG_PURGE) pkg-dir-file-moved

	# Switch a directory to a symlink, contents moved to another package,
	# with full installs, upgrade with upack and configure.
	$(DPKG_INSTALL) pkg-dir-symlink-ext-0.deb
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	$(DPKG_INSTALL) pkg-dir-file-moved.deb
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	test -d '$(DPKG_INSTDIR)/test-dir'
	$(DPKG_UNPACK) pkg-dir-symlink-ext-1.deb
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	test -d '$(DPKG_INSTDIR)/test-dir'
	$(DPKG_CONFIGURE) -a
	test -h '$(DPKG_INSTDIR)/test-path/test-subpath'
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	test "`readlink '$(DPKG_INSTDIR)/test-path/test-subpath'`" = "../test-dir"
	! test -h '$(DPKG_INSTDIR)/test-dir'
	test -d '$(DPKG_INSTDIR)/test-dir'
	test -f '$(DPKG_INSTDIR)/test-dir/file-normal'
	$(DPKG_PURGE) pkg-dir-symlink-ext
	$(DPKG_PURGE) pkg-dir-file-moved

	# Switch a directory to a symlink, contents moved to another package,
	# with three unpacks and configure.
	$(DPKG_UNPACK) pkg-dir-symlink-ext-0.deb
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	$(DPKG_UNPACK) pkg-dir-file-moved.deb
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	test -d '$(DPKG_INSTDIR)/test-dir'
	$(DPKG_UNPACK) pkg-dir-symlink-ext-1.deb
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	test -d '$(DPKG_INSTDIR)/test-dir'
	$(DPKG_CONFIGURE) -a
	test -h '$(DPKG_INSTDIR)/test-path/test-subpath'
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	test "`readlink '$(DPKG_INSTDIR)/test-path/test-subpath'`" = "../test-dir"
	! test -h '$(DPKG_INSTDIR)/test-dir'
	test -d '$(DPKG_INSTDIR)/test-dir'
	test -f '$(DPKG_INSTDIR)/test-dir/file-normal'
	$(DPKG_PURGE) pkg-dir-symlink-ext
	$(DPKG_PURGE) pkg-dir-file-moved

test-clean:
	$(DPKG_PURGE) pkg-dir-conffile
	$(DPKG_PURGE) pkg-dir-symlink-int
	$(DPKG_PURGE) pkg-dir-symlink-ext
	$(DPKG_PURGE) pkg-dir-file-other
	$(DPKG_PURGE) pkg-dir-file-moved

=== debian/changelog ===
dpkg (1.22.6ubuntu6.5) noble-security; urgency=medium

  [ Joy Latten ]
  * SECURITY UPDATE:
  - Fix cleanup for control member with restricted directories. LP: #2122053
  - Fixes CVE-2025-6297

 -- Serge Hallyn <serge.hallyn@ubuntu.com>  Thu, 18 Sep 2025 12:43:59 -0500

=== debian/control ===
Source: dpkg
Section: admin
Priority: required
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Dpkg Developers <debian-dpkg@lists.debian.org>
Uploaders: Guillem Jover <guillem@debian.org>
Homepage: https://wiki.debian.org/Teams/Dpkg
Vcs-Browser: https://git.dpkg.org/cgit/dpkg/dpkg.git
Vcs-Git: https://git.dpkg.org/git/dpkg/dpkg.git
Standards-Version: 4.6.2
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 debhelper (>= 13.10~),
 pkgconf,
# Version needed for ITS support.
 gettext (>= 0.19.7),
# Version needed for --porefs defaults, conditional addenda and mode=eof.
 po4a (>= 0.59),
 libmd-dev,
 zlib1g-dev,
 libbz2-dev,
# Version needed for multi-threaded decompressor support.
 liblzma-dev (>= 5.4.0),
# Version needed for the new streaming API.
 libzstd-dev (>= 1.4.0),
 libselinux1-dev [linux-any],
 libncurses-dev (>= 6.1+20180210),
# Needed for the functional test.
 bzip2 <!nocheck>,
# Version needed for multi-threaded decompressor support.
 xz-utils (>= 5.4.0) <!nocheck>,
# Needed for the functional test.
 zstd <!nocheck>,
# Needed for the author release process.
 git <pkg.dpkg.author-release>,
 ca-certificates <pkg.dpkg.author-release>,
 libmodule-build-perl <pkg.dpkg.author-release>,
# Needed for the test suite in author mode.
 fakeroot <pkg.dpkg.author-testing>,
 gnupg <pkg.dpkg.author-testing>,
 cppcheck <pkg.dpkg.author-testing>,
 shellcheck <pkg.dpkg.author-testing>,
 aspell <pkg.dpkg.author-testing>,
 aspell-en <pkg.dpkg.author-testing>,
 codespell <pkg.dpkg.author-testing>,
 i18nspector <pkg.dpkg.author-testing>,
 libtest-minimumversion-perl <pkg.dpkg.author-testing>,
 libtest-perl-critic-perl <pkg.dpkg.author-testing>,
 libtest-pod-coverage-perl <pkg.dpkg.author-testing>,
 libtest-pod-perl <pkg.dpkg.author-testing>,
 libtest-spelling-perl <pkg.dpkg.author-testing>,
 libtest-strict-perl <pkg.dpkg.author-testing>,
 libtest-synopsis-perl <pkg.dpkg.author-testing>,
# Needed for code coverage reports.
 lcov <pkg.dpkg.code-coverage>,
 libdevel-cover-perl <pkg.dpkg.code-coverage>,

Package: dpkg
Architecture: any
Multi-Arch: foreign
Essential: yes
Pre-Depends:
 ${shlibs:Depends},
Depends:
 ${misc:Depends},
# Version needed for --clamp-mtime in dpkg-deb -b.
 tar (>= 1.28-1),
Suggests:
 apt,
 debsig-verify,
Breaks:
# Due to --status-fd not duplicating output.
 libapt-pkg5.0 (<< 1.7~b),
# Due to s-s-d requiring secure usage of --pidfile.
 lsb-base (<< 10.2019031300),
Description: Debian package management system
 This package provides the low-level infrastructure for handling the
 installation and removal of Debian software packages.
 .
 For Debian package development tools, install dpkg-dev.

Package: libdpkg-dev
Section: libdevel
Priority: optional
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 libmd-dev,
 zlib1g-dev,
# Version needed for multi-threaded decompressor support.
 liblzma-dev (>= 5.4.0),
# Version needed for the new streaming API.
 libzstd-dev (>= 1.4.0),
 libbz2-dev,
Description: Debian package management static library
 This package provides the header files and static library necessary to
 develop software using libdpkg, the same library used internally by dpkg.
 .
 Note though, that the API is to be considered volatile, and might change
 at any time, use at your own risk.

Package: dpkg-dev
Section: utils
Priority: optional
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${perl:Depends},
 libdpkg-perl (= ${source:Version}),
# Version needed for --clamp-mtime.
 tar (>= 1.28-1),
 bzip2,
# Version needed for multi-threaded decompressor support.
 xz-utils (>= 5.4.0),
# Version needed for git-style diff support.
 patch (>= 2.7),
 make,
 binutils,
 lto-disabled-list,
Recommends:
 build-essential,
 gcc | c-compiler,
 fakeroot,
 gnupg | sq | sqop | pgpainless-cli | sequoia-chameleon-gnupg,
 gpgv | sq | sqop | pgpainless-cli | sequoia-chameleon-gnupg,
# Used by dpkg-mergechangelogs.
 libalgorithm-merge-perl,
Suggests:
 debian-keyring,
Breaks:
# Force R³ support, w/o requiring debhelper users to depend on dpkg-dev.
 debhelper (<< 10.10.1~),
# Uses new sq features, w/o requiring a hard dependency on sq.
 sq (<< 0.33.0~),
# Uses required SOP features, w/o requiring a hard dependency on sqop.
 sqop (<< 0.27.2~),
# Uses required SOP features, w/o requiring a hard dependency on pgpainless.
 pgpainless-cli (<< 1.3.13~),
 libsop-java-java (<< 4.0.7~),
Provides:
 dpkg-build-api (= 0),
 dpkg-build-api (= 1),
Description: Debian package development tools
 This package provides the development tools (including dpkg-source)
 required to unpack, build and upload Debian source packages.
 .
 Most Debian source packages will require additional tools to build;
 for example, most packages need make and the C compiler gcc.

Package: libdpkg-perl
Section: perl
Priority: optional
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${perl:Depends},
# Version needed for arch tuples.
 dpkg (>= 1.18.11),
Recommends:
# Used by Dpkg::File.
 libfile-fcntllock-perl,
# Used by Dpkg::Gettext.
 liblocale-gettext-perl,
 bzip2,
# Version needed for multi-threaded decompressor support.
 xz-utils (>= 5.4.0),
Suggests:
 debian-keyring,
 gnupg | sq | sqop | pgpainless-cli | sequoia-chameleon-gnupg,
 gpgv | sq | sqop | pgpainless-cli | sequoia-chameleon-gnupg,
 gcc | c-compiler,
 binutils,
 patch,
# Used (if available) by Dpkg::Source::Package::V2.
 sensible-utils,
# Needed by Dpkg::Source::Package::V3::Git
 git,
# Needed by Dpkg::Source::Package::V3::Bzr
 bzr,
Breaks:
# Uses the private Dpkg::Shlibs::SymbolFile module with no API stability
# guarantees! Which obviously broke with 1.19.0.
 pkg-kde-tools (<< 0.15.28~),
# Uses Dpkg::Compression::Process imported from Dpkg::Source::Package in
# versions prior to 1.19.0.
 dgit (<< 3.13~),
# Uses new sq features, w/o requiring a hard dependency on sq.
 sq (<< 0.33.0~),
# Uses required SOP features, w/o requiring a hard dependency on sqop.
 sqop (<< 0.27.2~),
# Uses required SOP features, w/o requiring a hard dependency on pgpainless.
 pgpainless-cli (<< 1.3.13~),
 libsop-java-java (<< 4.0.7~),
Description: Dpkg perl modules
 This package provides the perl modules used by the scripts
 in dpkg-dev. They cover a wide range of functionality. Among them
 there are the following public modules:
 .
  - Dpkg: core variables
  - Dpkg::Arch: architecture handling functions
  - Dpkg::BuildFlags: set, modify and query compilation build flags
  - Dpkg::BuildInfo: build information functions
  - Dpkg::BuildOptions: parse and manipulate DEB_BUILD_OPTIONS
  - Dpkg::BuildProfiles: parse and manipulate build profiles
  - Dpkg::Changelog: parse changelogs
  - Dpkg::Changelog::Entry: represents a changelog entry
  - Dpkg::Changelog::Parse: generic changelog parser for dpkg-parsechangelog
  - Dpkg::Checksums: generate and parse checksums
  - Dpkg::Compression: simple database of available compression methods
  - Dpkg::Compression::FileHandle: transparently (de)compress files
  - Dpkg::Compression::Process: wrapper around compression tools
  - Dpkg::Conf: parse dpkg configuration files
  - Dpkg::Control: parse and manipulate Debian control information
    (.dsc, .changes, Packages/Sources entries, etc.)
  - Dpkg::Control::Changelog: represent fields output by dpkg-parsechangelog
  - Dpkg::Control::Fields: manage (list of known) control fields
  - Dpkg::Control::Hash: parse and manipulate a block of RFC822-like fields
  - Dpkg::Control::Info: parse files like debian/control
  - Dpkg::Control::Tests: parse files like debian/tests/control
  - Dpkg::Control::Tests::Entry: represents a debian/tests/control stanza
  - Dpkg::Deps: parse and manipulate dependencies
  - Dpkg::Deps::Simple: represents a single dependency statement
  - Dpkg::Deps::Multiple: base module to represent multiple dependencies
  - Dpkg::Deps::Union: list of unrelated dependencies
  - Dpkg::Deps::AND: list of AND dependencies
  - Dpkg::Deps::OR: list of OR dependencies
  - Dpkg::Deps::KnownFacts: list of installed and virtual packages
  - Dpkg::Exit: push, pop and run exit handlers
  - Dpkg::Gettext: wrapper around Locale::gettext
  - Dpkg::IPC: spawn sub-processes and feed/retrieve data
  - Dpkg::Index: collections of Dpkg::Control (Packages/Sources files for
    example)
  - Dpkg::Interface::Storable: base object serializer
  - Dpkg::Path: common path handling functions
  - Dpkg::Source::Format: manipulate debian/source/format files
  - Dpkg::Source::Package: extract Debian source packages
  - Dpkg::Substvars: substitute variables in strings
  - Dpkg::Vendor: identify current distribution vendor
  - Dpkg::Version: parse and manipulate Debian package versions
 .
 All the packages listed in Suggests or Recommends are used by some of the
 modules.

Package: dselect
Priority: optional
Architecture: any
Multi-Arch: foreign
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Suggests:
 libdpkg-perl,
 perl,
Description: Debian package management front-end
 dselect is a high-level interface for managing the installation and
 removal of Debian software packages.
 .
 Many users find dselect intimidating and new users may prefer to use
 apt-based user interfaces.

=== scripts/t/mk/debian/control ===
Source: source
Build-Depends:
 dpkg-build-api (= 0),

Package: binary
Architecture: all

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for the dpkg suite.
# Copyright © 2004 Scott James Remnant <scott@netsplit.com>
# Copyright © 2006-2012 Guillem Jover <guillem@debian.org>

WFLAGS := \
	-Wall -Wextra \
	-Wno-missing-field-initializers \
	-Wno-nonnull-compare \
	-Wno-unused-parameter \
	# EOL

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = $(WFLAGS)
export DEB_CXXFLAGS_MAINT_APPEND = $(WFLAGS)

# Use the in-tree dpkg-buildflags
dpkg_buildflags = \
	DEB_BUILD_MAINT_OPTIONS="$(DEB_BUILD_MAINT_OPTIONS)" \
	DEB_CFLAGS_MAINT_APPEND="$(WFLAGS)" \
	DEB_CXXFLAGS_MAINT_APPEND="$(WFLAGS)" \
	$(CURDIR)/build-aux/run-script scripts/dpkg-buildflags.pl

# Do not enable everything on all platforms.
ifeq ($(DEB_HOST_ARCH_OS),linux)
	confflags += --with-libselinux
endif
ifeq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
	TESTSUITEFLAGS += --verbose
endif

# Enable parallel test suite
NUMJOBS = 1
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  TESTSUITEFLAGS += -j$(NUMJOBS)
endif

testflags = TESTSUITEFLAGS=$(TESTSUITEFLAGS) TEST_PARALLEL=$(NUMJOBS)

dpkg_vendor = \
	$(CURDIR)/build-aux/run-script scripts/dpkg-vendor.pl

DEB_VENDOR = $(shell $(call dpkg_vendor) --query Vendor)

D := $(CURDIR)/debian/tmp

%:
	dh $@ --builddirectory=build-tree

override_dh_auto_configure:
	dh_auto_configure -- \
		$(confflags) \
		$(shell $(dpkg_buildflags) --export=configure) \
		--libexecdir=\$${exec_prefix}/lib \
		--with-devlibdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH) \
		--with-libz \
		--with-liblzma \
		--with-libzstd \
		--with-libbz2 \
		# EOL

execute_after_dh_auto_install:
	# Special-case the lintian profile, as dh cannot rename on install.
	mkdir -p $(D)/usr/share/lintian/profiles/dpkg
	cp debian/dpkg.lintian-profile \
	   $(D)/usr/share/lintian/profiles/dpkg/main.profile

override_dh_auto_test:
	dh_auto_test -- $(testflags)

override_dh_installsystemd:
	dh_installsystemd -a --name=dpkg-db-backup \
	  --no-start --no-stop-on-upgrade

execute_after_dh_installlogrotate:
	dh_installlogrotate --name=alternatives

override_dh_installdocs:
	dh_installdocs -Ndpkg-dev
	dh_installdocs -pdpkg-dev --doc-main-package=dpkg

override_dh_installchangelogs:
	dh_installchangelogs --no-trim

override_dh_bugfiles:
	dh_bugfiles -A

override_dh_compress:
	dh_compress -Xspec/

ifeq (,$(filter $(DEB_VENDOR),Debian Ubuntu))
execute_after_dh_install:
	dh_install -pdpkg usr/sbin/dpkg-fsys-usrunmess

# XXX: We cannot use -X, see debhelper #756366.
execute_after_dh_installman:
	dh_installman -pdpkg $(wildcard \
	  $(D)/usr/share/man/*/dpkg-fsys-usrunmess.8  \
	  $(D)/usr/share/man/*/*/dpkg-fsys-usrunmess.8 \
	)

# XXX: We cannot pass pathnames to dh_installman w/o $(D), and then dh_missing
# complains that the pathnames do not match, so ignore them.
override_dh_missing:
	dh_missing -Xdpkg-fsys-usrunmess.8
else
override_dh_missing:
	dh_missing -Xdpkg-fsys-usrunmess
endif

override_dh_builddeb:
	# Make debootstrap life easier on non-Debian based systems by
	# compressing dpkg.deb with xz instead of zstd.
	dh_builddeb -pdpkg -- -Zxz
	dh_builddeb -Ndpkg

=== debian/tests/control ===
Tests:
 test-not-root
Depends:
 build-essential,
 autoconf,
 pkgconf,
 libmd-dev,
 file,
Restrictions:
 superficial
 skippable

Tests:
 test-root
Depends:
 build-essential,
 autoconf,
 pkgconf,
 libmd-dev,
 file
Restrictions:
 superficial
 needs-root
 breaks-testbed

Tests:
 test-func
Depends:
 @,
 eatmydata,
Restrictions:
 allow-stderr

Tests:
 test-func-root
Depends:
 @,
 eatmydata,
Restrictions:
 allow-stderr
 needs-root
 breaks-testbed
